//----------------------------------------------------------------------//
// H2Tconv																//
//	CtH[														//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <mmsystem.h>
#include <algorithm>
#include <htmlhelp.h>
#include <Vcl.HtmlHelpViewer.hpp>
#include "UserFunc.h"
#include "Unit1.h"

#pragma link "Vcl.HTMLHelpViewer"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TH2TconvForm *H2TconvForm;

HINSTANCE	  hHHctrl	  = NULL;
FUNC_HtmlHelp lpfHtmlHelp = NULL;

//---------------------------------------------------------------------------
__fastcall TH2TconvForm::TH2TconvForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::FormCreate(TObject *Sender)
{
	VersionStr = "Version " + get_VersionStr(Application->ExeName);

	DropInitialize(Handle, HtmFileList);

	HC = new HtmConv();
	Converting = ConvReady = false;
	InhUpdateInf = false;

	CodePageComboBox->Items->Text =
		"ShiftJIS\r\n"
		"JIS (ISO-2022-JP)\r\n"
		"EUC-JP\r\n"
		"UTF-8\r\n"
		"UTF-16\r\n";

	//NIvV̏
	UnicodeString OutNam = EmptyStr;
	UnicodeString OutDir = EmptyStr;
	UnicodeString IniNam = EmptyStr;
	int i = 1;
	while (!ParamStr(i).IsEmpty()) {
		UnicodeString prmbuf = ParamStr(i++).Trim();
		//IvV
		if (prmbuf.SubString(1, 1)=="-") {
			//o̓t@Cw
			if (SameText(prmbuf.SubString(2, 1), "O")) {
				prmbuf.Delete(1, 2);
				if (!prmbuf.IsEmpty()) {
					OutDir = ExtractFileDir(prmbuf);
					OutNam = ExtractFileName(prmbuf);
				}
			}
			//ݒt@C̎w
			else if (SameText(prmbuf.SubString(2, 1), "I")) {
				prmbuf.Delete(1, 2);
				IniNam = prmbuf;
			}
		}
		//̓t@C
		else {
			UnicodeString fmsk = ExtractFileName(prmbuf);
			UnicodeString idir = ExtractFileDir(prmbuf);
			if (fmsk.Pos("*")>0 || fmsk.Pos("?")>0)
				get_all_files(idir, fmsk, HtmFileList->Items, false);
			else
				AddStrToList(prmbuf);
		}
	}

	//ݒ̓Ǎ
	IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
	if (!IniNam.IsEmpty()){
		get_file_name_r(IniNam);
		LoadIniFile(IniNam);
	}
	else
		LoadIniFile();

	AutoStart = false;
	if (HtmFileList->Items->Count>0) {
		if (!OutDir.IsEmpty()) {
			DstDirEdit->Text = OutDir;
			DestMode = DSTMOD_SELDIR;
		}
		if (!OutNam.IsEmpty()) {
			FilNamEdit->Text = OutNam;
			FilNamEdit->Modified = true;
			if (DestMode==DSTMOD_CLIPBD) DestMode = DSTMOD_ORGDIR;
		}
		UpdateInf(false);
		AutoStart = ConvReady;
	}

	if (AutoStart) {
		//Cʂ\AϊsɏI
		ConvertExecute(NULL);
		Application->Terminate();
	}
	else {
	 	Show();
	}
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::FormShow(TObject *Sender)
{
	//wvt@C
	Application->HelpFile = ChangeFileExt(Application->ExeName, ".CHM");
	hHHctrl = ::LoadLibrary(_T("hhctrl.ocx"));
	if (hHHctrl) lpfHtmlHelp = (FUNC_HtmlHelp)::GetProcAddress(hHHctrl, "HtmlHelpW");

	//ʏԂ𕜌
	UnicodeString sct = "General";
	CmpPosCombo->ItemIndex = IniFile->ReadInteger(sct, "CompactPos", 0);
	Compact = IniFile->ReadBool(sct, "Compact",	false);
	if (Compact) {
		Constraints->MinWidth  = CMP_MIN_WD;
		Constraints->MinHeight = CMP_MIN_HI;
		Width  = IniFile->ReadInteger(sct, "WinWidthC",  CMP_MIN_WD);
		Height = IniFile->ReadInteger(sct, "WinHeightC", CMP_MIN_HI);
	}
	else {
		Constraints->MinWidth  = NRM_MIN_WD;
		Constraints->MinHeight = NRM_MIN_HI;
		Width  = IniFile->ReadInteger(sct, "WinWidth",  NRM_MIN_WD);
		Height = IniFile->ReadInteger(sct, "WinHeight", NRM_MIN_HI);
	}
	Left = IniFile->ReadInteger(sct, "WinLeft",	0);
	Top  = IniFile->ReadInteger(sct, "WinTop",	0);

	TopMostCheck->Checked	= IniFile->ReadBool(sct, "TopMost", false);
	if (TopMostCheck->Checked)
		::EndDeferWindowPos(DeferWindowPos(BeginDeferWindowPos(1),
			Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE));

	SetFrmStyle();

	//̑̈ʐݒ
	LastIniDir = IniFile->ReadString(sct, "LastIniDir",	ExtractFileDir(Application->ExeName));

	ConvBtnC->Parent = H2TconvForm;
}

//---------------------------------------------------------------------------
//ʃTCY̏
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::FormResize(TObject *Sender)
{
	if (Compact) {
		GrpBox1_1->Width  = ClientWidth - ConvBtnC->Width - 10;
		GrpBox1_1->Height = ClientHeight;
	}

	if (Screen->MonitorCount==1) {
		//ʒuʓɐ
		if (BoundsRect.Right>Screen->Width)
			Left = Screen->Width - Width;
		else if (Left<0)
			Left = 0;

		if (BoundsRect.Bottom>Screen->Height)
			Top = Screen->Height - Height;
		else if (Top<0)
			Top = 0;
	}

	SetFrmStyle();
}

//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (!AutoStart) {
		//ʏԂۑ
		UnicodeString sct = "General";
		IniFile->WriteInteger(sct, "WinTop",   		Top);
		IniFile->WriteInteger(sct, "WinLeft",  		Left);
		if (Compact) {
			IniFile->WriteInteger(sct, "WinWidthC", 	Width);
			IniFile->WriteInteger(sct, "WinHeightC",	Height);
		}
		else {
			IniFile->WriteInteger(sct, "WinWidth", 	Width);
			IniFile->WriteInteger(sct, "WinHeight",	Height);
		}
		IniFile->WriteBool(   sct, "Compact",		Compact);
		IniFile->WriteInteger(sct, "CompactPos",	CmpPosCombo->ItemIndex);
		IniFile->WriteBool(   sct, "TopMost",		TopMostCheck->Checked);

		//eݒۑ
		IniFile->WriteString(sct, "LastIniDir",		LastIniDir);

		SaveIniFile();
	}
}

//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::FormDestroy(TObject *Sender)
{
	delete HC;
	delete IniFile;

	DropUninitialize();

	if (hHHctrl) ::FreeLibrary(hHHctrl);
}

//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::ApplicationEvents1Message(tagMSG &Msg, bool &Handled)
{
	//wṽL[bZ[W
	if (lpfHtmlHelp) {
		Handled = (lpfHtmlHelp(NULL, NULL, HH_PRETRANSLATEMESSAGE, (DWORD)&Msg) != NULL);
	}
}

//---------------------------------------------------------------------
//ʂړꂽƂ̏
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::WMMove(TMessage &Msg)
{
	if (Screen->MonitorCount==1) {
		//ʂ͂ݏo߂
		if (BoundsRect.Right>Screen->Width)
			Left = Screen->Width - Width;
		else if (Left<0)
			Left = 0;

		if (BoundsRect.Bottom>Screen->Height)
			Top = Screen->Height - Height;
		else if (Top<0)
			Top = 0;
	}
}

//---------------------------------------------------------------------------
//hbv̎󂯓
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::WmDropped(TMessage &msg)
{
	if (!Converting && (DroppedMode==DROPEFFECT_COPY || DroppedMode==DROPEFFECT_LINK)) {
		int lastn = HtmFileList->Items->Count;

		for (int i=0; i<DroppedList->Count; i++) {
			UnicodeString fnam = DroppedList->Strings[i];
			if (EndsStr("\\", fnam))
				get_all_files(fnam, "*.*htm*", HtmFileList->Items, DropSubCheck->Checked);
			else if (HtmFileList->Items->IndexOf(fnam)==-1)
				HtmFileList->Items->Add(fnam);
		}

		if (lastn==0) {
			HtmFileList->Sorted = true;
			HtmFileList->Sorted = false;
		}

		UpdateInf(true);
	}

	DroppedList->Clear();
	::SetForegroundWindow(Handle);
}

//---------------------------------------------------------------------------
//ݒ̓Ǎ
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::LoadIniFile(UnicodeString fnam)
{
	TIniFile *ini_file;
	if (!fnam.IsEmpty())
		ini_file = new TIniFile(fnam);
	else
		ini_file = IniFile;

	UnicodeString sct = "Option";
	LastDir 				= ini_file->ReadString( sct, "LastDir",		EmptyStr);
	OpenAppCheck->Checked	= ini_file->ReadBool(   sct, "OpenApp",		false);
	AppNameEdit->Text		= ini_file->ReadString( sct, "AppName",		"notepad");
	DestMode				= ini_file->ReadInteger(sct, "Destination",	DSTMOD_CLIPBD);
	UpdateInf(true);
	DstDirEdit->Text		= ini_file->ReadString( sct, "DstDir",		EmptyStr);
	JoinCheck->Checked		= ini_file->ReadBool(   sct, "JoinText",	false);
	Tit2NamCheck->Checked	= ini_file->ReadBool(   sct, "Title2Name",	false);
	TitLmtUpDown->Position	= ini_file->ReadInteger(sct, "TitleLimit",	40);
	TitCvExChCheck->Checked	= ini_file->ReadBool(   sct, "TitleCvExCh",	false);
	TitCvSpcCheck->Checked	= ini_file->ReadBool(   sct, "TitleCvSpc",	false);
	Tit2NamCheckClick(NULL);
	AddNoCheck->Checked 	= ini_file->ReadBool(   sct, "AddSerNo",	false);
	KillCheck->Checked		= ini_file->ReadBool(   sct, "KillHtml",	false);
	SureKillCheck->Checked	= ini_file->ReadBool(   sct, "SureKill",	false);
	InsHdCheck->Checked 	= ini_file->ReadBool(   sct, "InsertHead",	false);
	InsFtCheck->Checked 	= ini_file->ReadBool(   sct, "InsertFoot",	false);
	HeadMemo->Lines->Text
		= esc_to_str(ini_file->ReadString(sct, "HeadText", "^Cg [$TITLE]\\n$LINE2"));
	FootMemo->Lines->Text
		= esc_to_str(ini_file->ReadString(sct, "FootText", EmptyStr));
	EndSoundEdit->Text		= ini_file->ReadString(sct, "EndSound",			EmptyStr);
	UseTrashCheck->Checked	= ini_file->ReadBool(  sct, "UseTrashCan",		true);
	DropSubCheck->Checked	= ini_file->ReadBool(  sct, "DropSubdir",		true);
	CodePageComboBox->ItemIndex = ini_file->ReadInteger(sct, "OutCodePage",	0);

	sct = "Convert";
	LnWidUpDown->Position	  = ini_file->ReadInteger(sct, "LineWidth",		DEF_LINE_WIDTH);
	FrcCrCheck->Checked 	  = ini_file->ReadBool(   sct, "ForceCr",		false);
	PstHdrCheck->Checked	  = ini_file->ReadBool(   sct, "NoPostHdr",		false);
	BlkLmtUpDown->Position	  = ini_file->ReadInteger(sct, "BlankLnLimit", 	DEF_BLANK_LN_LIMIT);
	HrStrEdit->Text 		  = ini_file->ReadString( sct, "HrLineStr",		"");
	H1Edit->Text			  = ini_file->ReadString( sct, "H1Str",			"");
	H2Edit->Text			  = ini_file->ReadString( sct, "H2Str",			"");
	H3Edit->Text			  = ini_file->ReadString( sct, "H3Str",			"");
	H4Edit->Text			  = ini_file->ReadString( sct, "H4Str",			"");
	H5Edit->Text			  = ini_file->ReadString( sct, "H5Str",			"");
	H6Edit->Text			  = ini_file->ReadString( sct, "H6Str",			"");
	B_BraEdit->Text 		  = ini_file->ReadString( sct, "B_BraStr",		EmptyStr);
	B_KetEdit->Text 		  = ini_file->ReadString( sct, "B_KetStr",		EmptyStr);
	I_BraEdit->Text 		  = ini_file->ReadString( sct, "I_BraStr",		EmptyStr);
	I_KetEdit->Text 		  = ini_file->ReadString( sct, "I_KetStr",		EmptyStr);
	U_BraEdit->Text 		  = ini_file->ReadString( sct, "U_BraStr",		EmptyStr);
	U_KetEdit->Text 		  = ini_file->ReadString( sct, "U_KetStr",		EmptyStr);
	IndentEdit->Text		  = ini_file->ReadString( sct, "IndentStr",		"\\s\\s");
	MarkEdit->Text			  = ini_file->ReadString( sct, "UlMarkStr",		"E");
	ZenNoCheck->Checked 	  = ini_file->ReadBool(   sct, "ZenNumber",		false);
	CelSepEdit->Text		  = ini_file->ReadString( sct, "CellSepStr",	"\\t");
	AltCheck->Checked		  = ini_file->ReadBool(   sct, "UseAltStr",		false);
	ImgSrcCheck->Checked	  = ini_file->ReadBool(   sct, "AddImgSrc",		false);
	AltBraEdit->Text		  = ini_file->ReadString( sct, "AltBraStr",		"[");
	AltKetEdit->Text		  = ini_file->ReadString( sct, "AltKetStr",		"]");
	DefAltEdit->Text		  = ini_file->ReadString( sct, "DefAltStr",		"摜");
	LinkCheck->Checked		  = ini_file->ReadBool(   sct, "InsertLink",	false);
	ExtLnkCheck->Checked	  = ini_file->ReadBool(   sct, "OnlyExLink",	true);
	LinkCrCheck->Checked	  = ini_file->ReadBool(   sct, "AddCrLink",		false);
	LnkBraEdit->Text		  = ini_file->ReadString( sct, "LinkBraStr",	"i");
	LnkKetEdit->Text		  = ini_file->ReadString( sct, "LinkKetStr",	"j");
	InsLineStrEdit->Text	  = ini_file->ReadString( sct, "InsLineStr",	"");
	InsHrClsEdit->Text		  = ini_file->ReadString( sct, "InsHrClass",	EmptyStr);
	InsHrSctCheckBox->Checked = ini_file->ReadBool(   sct, "InsHrSct",		false);
	InsHrArtCheckBox->Checked = ini_file->ReadBool(   sct, "InsHrArt",		false);
	InsHrNavCheckBox->Checked = ini_file->ReadBool(   sct, "InsHrNav",		false);
	DelBlkClsEdit->Text 	  = ini_file->ReadString( sct, "DelBlkCls",		EmptyStr);
	DelBlkIdEdit->Text		  = ini_file->ReadString( sct, "DelBlkId",		EmptyStr);

	AltCheckClick(NULL);
	LinkCheckClick(NULL);

	if (!fnam.IsEmpty()) {
		Caption = UnicodeString().sprintf(_T("%s - [%s]"), Application->Title, ExtractFileName(fnam));
		delete ini_file;
	}
	else
		Caption = Application->Title;
}
//---------------------------------------------------------------------------
//ݒ̕ۑ
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::SaveIniFile(UnicodeString fnam)
{
	TIniFile *ini_file;
	if (!fnam.IsEmpty())
		ini_file = new TIniFile(fnam);
	else
		ini_file = IniFile;

	UnicodeString sct = "Option";
	ini_file->WriteInteger(sct, "Destination",	DestMode);
	ini_file->WriteString( sct, "LastDir",		LastDir);
	ini_file->WriteBool(   sct, "OpenApp",		OpenAppCheck->Checked);
	ini_file->WriteString( sct, "AppName",		AppNameEdit->Text);
	ini_file->WriteString( sct, "DstDir", 		DstDirEdit->Text);
	ini_file->WriteBool(   sct, "JoinText",		JoinCheck->Checked);
	ini_file->WriteBool(   sct, "Title2Name",	Tit2NamCheck->Checked);
	ini_file->WriteString( sct, "TitleLimit",	TitLmtEdit->Text);
	ini_file->WriteBool(   sct, "TitleCvExCh",	TitCvExChCheck->Checked);
	ini_file->WriteBool(   sct, "TitleCvSpc",	TitCvSpcCheck->Checked);
	ini_file->WriteBool(   sct, "AddSerNo",		AddNoCheck->Checked);
	ini_file->WriteBool(   sct, "KillHtml",		KillCheck->Checked);
	ini_file->WriteBool(   sct, "SureKill",		SureKillCheck->Checked);
	ini_file->WriteBool(   sct, "InsertHead",	InsHdCheck->Checked);
	ini_file->WriteBool(   sct, "InsertFoot",	InsFtCheck->Checked);
	ini_file->WriteString( sct, "HeadText",		str_to_esc(HeadMemo->Lines->Text));
	ini_file->WriteString( sct, "FootText",		str_to_esc(FootMemo->Lines->Text));
	ini_file->WriteString( sct, "EndSound",		EndSoundEdit->Text);
	ini_file->WriteBool(   sct, "UseTrashCan",	UseTrashCheck->Checked);
	ini_file->WriteBool(   sct, "DropSubdir",	DropSubCheck->Checked);
	ini_file->WriteInteger(sct, "OutCodePage",	CodePageComboBox->ItemIndex);

	sct = "Convert";
	ini_file->WriteString( sct, "LineWidth",	LnWidEdit->Text);
	ini_file->WriteBool(   sct, "ForceCr",		FrcCrCheck->Checked);
	ini_file->WriteString( sct, "BlankLnLimit",	BlkLmtEdit->Text);
	ini_file->WriteBool(   sct, "NoPostHdr",	PstHdrCheck->Checked);
	ini_file->WriteString( sct, "HrLineStr",	HrStrEdit->Text);
	ini_file->WriteString( sct, "H1Str",		H1Edit->Text);
	ini_file->WriteString( sct, "H2Str",		H2Edit->Text);
	ini_file->WriteString( sct, "H3Str",		H3Edit->Text);
	ini_file->WriteString( sct, "H4Str",		H4Edit->Text);
	ini_file->WriteString( sct, "H5Str",		H5Edit->Text);
	ini_file->WriteString( sct, "H6Str",		H6Edit->Text);
	ini_file->WriteString( sct, "B_BraStr",		B_BraEdit->Text);
	ini_file->WriteString( sct, "B_KetStr",		B_KetEdit->Text);
	ini_file->WriteString( sct, "I_BraStr",		I_BraEdit->Text);
	ini_file->WriteString( sct, "I_KetStr",		I_KetEdit->Text);
	ini_file->WriteString( sct, "U_BraStr",		U_BraEdit->Text);
	ini_file->WriteString( sct, "U_KetStr",		U_KetEdit->Text);
	ini_file->WriteString( sct, "IndentStr",	IndentEdit->Text);
	ini_file->WriteString( sct, "UlMarkStr",	MarkEdit->Text);
	ini_file->WriteBool(   sct, "ZenNumber",	ZenNoCheck->Checked);
	ini_file->WriteString( sct, "CellSepStr",	CelSepEdit->Text);
	ini_file->WriteBool(   sct, "UseAltStr",	AltCheck->Checked);
	ini_file->WriteBool(   sct, "AddImgSrc",	ImgSrcCheck->Checked);
	ini_file->WriteString( sct, "AltBraStr",	AltBraEdit->Text);
	ini_file->WriteString( sct, "AltKetStr",	AltKetEdit->Text);
	ini_file->WriteString( sct, "DefAltStr",	DefAltEdit->Text);
	ini_file->WriteBool(   sct, "InsertLink",	LinkCheck->Checked);
	ini_file->WriteBool(   sct, "OnlyExLink", 	ExtLnkCheck->Checked);
	ini_file->WriteBool(   sct, "AddCrLink", 	LinkCrCheck->Checked);
	ini_file->WriteString( sct, "LinkBraStr",	LnkBraEdit->Text);
	ini_file->WriteString( sct, "LinkKetStr",	LnkKetEdit->Text);
	ini_file->WriteString( sct, "InsLineStr",	InsLineStrEdit->Text);
	ini_file->WriteString( sct, "InsHrClass",	InsHrClsEdit->Text);
	ini_file->WriteBool(   sct, "InsHrSct",		InsHrSctCheckBox->Checked);
	ini_file->WriteBool(   sct, "InsHrArt",		InsHrArtCheckBox->Checked);
	ini_file->WriteBool(   sct, "InsHrNav",		InsHrNavCheckBox->Checked);
	ini_file->WriteString( sct, "DelBlkCls",	DelBlkClsEdit->Text);
	ini_file->WriteString( sct, "DelBlkId",		DelBlkIdEdit->Text);

	if (!fnam.IsEmpty()) {
		Caption = UnicodeString().sprintf(_T("%s - [%s]"), Application->Title, ExtractFileName(fnam));
		delete ini_file;
	}
}

//---------------------------------------------------------------------
//t@CURLꗗɒǉ
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::AddStrToList(UnicodeString s)
{
	if (!s.IsEmpty()) {
		s = del_quot(s);
		if (StartsText("file:/", s)) {
			s.Delete(1, 6);
			if (StartsText("//", s)) s.Delete(1, 2);
			s = ReplaceStr(s, "|\\", ":\\");
			s = ReplaceStr(s, "/",	  "\\");
			s = ReplaceStr(s, "%20", " ");
		}
		if (HtmFileList->Items->IndexOf(s)==-1) HtmFileList->Items->Add(s);
		UpdateInf(true);
	}
}
//---------------------------------------------------------------------------
//̓t@CI
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::AddBtnClick(TObject *Sender)
{
	OpenDialog1->Title		= "HTML̑I";
	OpenDialog1->Filter 	= "HTML (*.*htm*)|*.*HTM*";
	OpenDialog1->DefaultExt = "HTML";
	OpenDialog1->FileName	= "*.*HTM*";
	OpenDialog1->InitialDir = LastDir;
	int lastn = HtmFileList->Items->Count;
	if (OpenDialog1->Execute()) {
 		for (int i=0; i<OpenDialog1->Files->Count; i++) {
			UnicodeString fnam = OpenDialog1->Files->Strings[i];
			if (HtmFileList->Items->IndexOf(fnam)==-1) HtmFileList->Items->Add(fnam);
		}
		LastDir = ExtractFileDir(OpenDialog1->FileName);
		if (lastn==0) {
			HtmFileList->Sorted = true;
			HtmFileList->Sorted = false;
		}
	}

	UpdateInf(true);
}
//---------------------------------------------------------------------------
//URL 
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::InputBtnClick(TObject *Sender)
{
	UnicodeString urlstr = InputBox(
		"", "t@CURL͂Ă", EmptyStr);
	if (!urlstr.IsEmpty()) AddStrToList(urlstr);
	UpdateInf(true);
}
//---------------------------------------------------------------------------
//Nbv{[h\t
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::PasteBtnClick(TObject *Sender)
{
	if (!Clipboard()->HasFormat(CF_TEXT)) return;

	std::unique_ptr<TStringList> tmpbuf(new TStringList());
	tmpbuf->Text = Clipboard()->AsText;
	for (int i=0; i<tmpbuf->Count; i++)
		if (!tmpbuf->Strings[i].IsEmpty()) AddStrToList(tmpbuf->Strings[i]);
	UpdateInf(true);
}
//---------------------------------------------------------------------------
//폜
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::DelBtnClick(TObject *Sender)
{
	int i = 0;
	while (i<HtmFileList->Items->Count) {
		if (HtmFileList->Selected[i])
			HtmFileList->Items->Delete(i);
		else
			i++;
	}
	UpdateInf(true);
}
//---------------------------------------------------------------------------
//NA
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::ClrBtnClick(TObject *Sender)
{
	HtmFileList->Clear();
	FilNamEdit->Text = EmptyStr;
	UpdateInf(true);
}
//---------------------------------------------------------------------------
//\[g
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::SortBtnClick(TObject *Sender)
{
	HtmFileList->Sorted = true;
	HtmFileList->Sorted = false;
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::UpItemBtnClick(TObject *Sender)
{
	if (HtmFileList->Items->Count<2) return;
	int n = HtmFileList->ItemIndex;
	if (n>0) {
		HtmFileList->Items->Move(n, n - 1);
		HtmFileList->ItemIndex = n - 1;
		HtmFileList->Selected[HtmFileList->ItemIndex] = true;
	}
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::DowItemBtnClick(TObject *Sender)
{
	if (HtmFileList->Items->Count<2) return;
	int n = HtmFileList->ItemIndex;
	if (n < (HtmFileList->Items->Count - 1)) {
		HtmFileList->Items->Move(n, n + 1);
		HtmFileList->ItemIndex = n + 1;
		HtmFileList->Selected[HtmFileList->ItemIndex] = true;
	}
}

//---------------------------------------------------------------------------
//ꗗł̃L[
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::HtmFileListKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
	switch (Key) {
	case VK_DELETE:
		DelBtnClick(NULL);
		break;
	case 'V':
		if (Shift.Contains(ssCtrl)) PasteBtnClick(NULL);
		break;
	}
}

//---------------------------------------------------------------------------
// URL Ȃt@CɓKȖOɕϊ
//---------------------------------------------------------------------
UnicodeString __fastcall TH2TconvForm::UrlToName(UnicodeString s)
{
	if (StartsText("http://", s) || StartsText("https://", s)) {
		s = get_tkn_r(s, "://");
		int p = s.Pos("?");
		if (p>0) s = s.SubString(1, p - 1);
		s = ReplaceStr(s, "/",	"\\");
		s = ChangeFileExt(s, EmptyStr);
		s = ReplaceStr(s, "\\",	"-");
		s = ReplaceStr(s, ".",	"_");
	}
	return s;
}
//---------------------------------------------------------------------------
// ^Cg񂩂KȖO
//---------------------------------------------------------------------
UnicodeString __fastcall TH2TconvForm::TitToName(UnicodeString s)
{
	// . \ / : * ? " < > |
	std::unique_ptr<TStringList> lst(new TStringList());
	if (TitCvExChCheck->Checked)
		lst->Text =
			".\tD\r\n"
			"\\\t\r\n"
			"/\t^\r\n"
			":\tF\r\n"
			"*\t\r\n"
			"?\tH\r\n"
			"\"\th\r\n"
			"<\t\r\n"
			">\t\r\n"
			"|\tb\r\n";
	else
		lst->Text =
			".\t\r\n"
			"\\\t\r\n"
			"/\t\r\n"
			":\t\r\n"
			"*\t\r\n"
			"?\t\r\n"
			"\"\t\r\n"
			"<\t\r\n"
			">\t\r\n"
			"|\t\r\n";
	s = replace_str_by_list(s, lst.get());

	if (TitCvSpcCheck->Checked) {
		s = ReplaceStr(s, " ",	"_");
		s = ReplaceStr(s, "@",	"_");
	}

	s = Trim(s);

	int maxl = TitLmtEdit->Text.ToIntDef(8);
	if (s.Length()>maxl) s.SetLength(maxl);

	if (s.IsEmpty()) s = "untitled";
	return s;
}
//---------------------------------------------------------------------------
// dꍇɃt@CɘAԂt
//---------------------------------------------------------------------
UnicodeString __fastcall TH2TconvForm::AddSerNo(UnicodeString s)
{
	UnicodeString ret = s;
	UnicodeString ext = ExtractFileExt(s);
	UnicodeString nam = ChangeFileExt(s, "");
	for (int n=0; true; n++) {
		if (n==0) {
			ret = nam + ext;
			if (!FileExists(ret)) break;
		}
		else {
			ret.sprintf(_T("%s(%u)%s"), nam, n, ext);
			if (!FileExists(ret)) break;
		}
	}
	return ret;
}

//---------------------------------------------------------------------------
//\X^C̐ݒ
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::SetFrmStyle()
{
	int w;
	if (!Compact) {
		ConvBtnC->Visible	  = false;
		StatusBar1->Visible   = true;
		CmpBtnPanel->Parent   = PageControl1;
		CmpBtnPanel->Left	  = PageControl1->Width - CmpBtnPanel->Width;
		CompactBtn->Caption   = "";
		CompactBtn->Hint	  = "RpNg\";
		GrpBox1_1->Parent	  = Panel1_1;
		GrpBox1_1->Align	  = alClient;
		w					  = 70;
		AddBtn->Left		  = 8;
		AddBtn->Caption 	  = "ǉ(&A)...";
		AddBtn->Width		  = w;
		InputBtn->Caption	  = "(&B)...";
		InputBtn->Width 	  = w;
		InputBtn->Left		  = AddBtn->Left + w + 2;
		PasteBtn->Caption	  = "\t(&P)";
		PasteBtn->Width 	  = w;
		PasteBtn->Left		  = InputBtn->Left + w + 2;
		w					  = 55;
		DelBtn->Caption 	  = "";
		DelBtn->Width		  = w;
		DelBtn->Left		  = PasteBtn->Left + w + 15 + 12;
		ClrBtn->Caption 	  = "NA";
		ClrBtn->Width		  = w;
		ClrBtn->Left		  = DelBtn->Left + w + 2;
		SortBtn->Caption	  = "\[g";
		SortBtn->Width		  = w;
		SortBtn->Left		  = ClrBtn->Left + w + 12;
		UpItemBtn->Caption	  = "";
		UpItemBtn->Width	  = w;
		UpItemBtn->Left 	  = SortBtn->Left + w + 2;
		DowItemBtn->Caption   = "";
		DowItemBtn->Width	  = w;
		DowItemBtn->Left	  = UpItemBtn->Left + w + 2;
		Panel3->Height		  = TabSheet3->Height/2;
		PageControl1->Visible = true;
	}
	else {
		StatusBar1->Visible   = false;
		PageControl1->Visible = false;
		CmpBtnPanel->Parent   = H2TconvForm;
		CompactBtn->Caption   = "";
		CompactBtn->Hint	  = "ʏ\";
		GrpBox1_1->Parent	  = H2TconvForm;
		GrpBox1_1->Align	  = alNone;
		GrpBox1_1->Left 	  = 0;
		GrpBox1_1->Top		  = 0;
		GrpBox1_1->Width	  = ClientWidth - ConvBtnC->Width - 10;
		GrpBox1_1->Height	  = ClientHeight;
		ConvBtnC->Left		  = ClientWidth - ConvBtnC->Width - 2;
		ConvBtnC->Top		  = ClientHeight - ConvBtnC->Height - 2;
		ConvBtnC->Visible	  = true;
		w					  = 28;
		AddBtn->Left		  = 4;
		AddBtn->Caption 	  = "";
		AddBtn->Width		  = w;
		InputBtn->Caption	  = "";
		InputBtn->Width 	  = w;
		InputBtn->Left		  = AddBtn->Left + w + 1;
		PasteBtn->Caption	  = "\";
		PasteBtn->Width 	  = w;
		PasteBtn->Left		  = InputBtn->Left + w + 1;
		DelBtn->Caption 	  = "";
		DelBtn->Width		  = w;
		DelBtn->Left		  = PasteBtn->Left + w + 4;
		ClrBtn->Caption 	  = "";
		ClrBtn->Width		  = w;
		ClrBtn->Left		  = DelBtn->Left + w + 1;
		SortBtn->Caption	  = "";
		SortBtn->Width		  = w;
		SortBtn->Left		  = ClrBtn->Left + w + 4;
		UpItemBtn->Caption	  = "";
		UpItemBtn->Width	  = w;
		UpItemBtn->Left 	  = SortBtn->Left + w + 1;
		DowItemBtn->Caption   = "";
		DowItemBtn->Width	  = w;
		DowItemBtn->Left	  = UpItemBtn->Left + w + 1;
	}

	SortBtn->Visible	= ((SortBtn->Left + SortBtn->Width) < GrpBox1_1->Width);
	UpItemBtn->Visible	= ((UpItemBtn->Left + UpItemBtn->Width) < GrpBox1_1->Width);
	DowItemBtn->Visible = ((DowItemBtn->Left + DowItemBtn->Width) < GrpBox1_1->Width);
}

//---------------------------------------------------------------------------
//ݒ̍XV
// chgf = true Ȃ FilNamEdit->Text ɃftHgݒ
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::UpdateInf(bool chgf)
{
	//dĂяo}~
	if (InhUpdateInf) return;
	InhUpdateInf = true;

	int HtmLstCnt = HtmFileList->Items->Count;
	bool only_one = (DestMode!=DSTMOD_CLIPBD && (HtmLstCnt==1 || JoinCheck->Checked));

	if (chgf) {
		//FilNamEdit->Text ftHgݒ
		UnicodeString fnam = EmptyStr;
		do {
			if (DestMode==DSTMOD_CLIPBD) break;
			if (HtmLstCnt==0) break;

			if (only_one)
				fnam = HtmFileList->Items->Strings[0];
			else {
				if (HtmFileList->ItemIndex==-1) break;
				fnam = HtmFileList->Items->Strings[HtmFileList->ItemIndex];
			}
			fnam = UrlToName(fnam);

			if (Tit2NamCheck->Checked) {
				if (isHtml(fnam) && FileExists(fnam)) {
					FilNamEdit->Text = TitToName(HC->GetTitle(fnam)) + ".txt";
					FilNamEdit->Font->Color = clWindowText;
				}
				else {
					FilNamEdit->Text = "(ϊɃ^Cg擾).txt";
					FilNamEdit->Font->Color = clRed;
				}
			}
			else {
				FilNamEdit->Text = ChangeFileExt(ExtractFileName(fnam), ".txt");
				FilNamEdit->Font->Color = clWindowText;
			}
			FilNamEdit->Modified = false;
		} while (0);
	}

	DelBtn->Enabled 	= (HtmFileList->SelCount>0);
	ClrBtn->Enabled 	= (HtmLstCnt>0);
	SortBtn->Enabled	= (HtmLstCnt>1);
	UpItemBtn->Enabled	= (HtmFileList->SelCount>0) && (HtmLstCnt>1);
	DowItemBtn->Enabled = (HtmFileList->SelCount>0) && (HtmLstCnt>1);

	//URL܂܂Ă邩?
	bool inc_url = false;
	for (int i=0; i<HtmLstCnt; i++) {
		UnicodeString htm = HtmFileList->Items->Strings[i];
		if (StartsText("http://", htm) || StartsText("https://", htm)) {
			inc_url = true; break;
		}
	}
	//SēfBNg?
	bool sam_dir = true;
	OrgDir = EmptyStr;
	for (int i=0; i<HtmFileList->Items->Count; i++) {
		if (i==0)
			OrgDir = ExtractFileDir(HtmFileList->Items->Strings[i]);
		else if (OrgDir!=ExtractFileDir(HtmFileList->Items->Strings[i])) {
			sam_dir = false; break;
		}
	}

	SamDirRadioBtn->Enabled = !inc_url;

	if (inc_url && (DestMode==DSTMOD_ORGDIR)) DestMode = DSTMOD_SELDIR;
	if (JoinCheck->Checked && !sam_dir && (DestMode==DSTMOD_ORGDIR)) DestMode = DSTMOD_SELDIR;

	ClipRadioBtn->Checked	= (DestMode==DSTMOD_CLIPBD);
	SamDirRadioBtn->Checked = (DestMode==DSTMOD_ORGDIR);
	SetDirRadioBtn->Checked = (DestMode==DSTMOD_SELDIR);

	DstDirEdit->Enabled 	= (DestMode==DSTMOD_SELDIR);
	RefDstBtn->Enabled		= (DestMode==DSTMOD_SELDIR);
	FilNamEdit->Enabled 	= only_one;
	OpenAppCheck->Enabled	= only_one;

	//ϊJn\?
	ConvReady = false;
	do {
		if (HtmLstCnt==0) {
			StatusBar1->SimpleText = "HTMLw肵Ă";
			break;
		}
		if (DestMode!=DSTMOD_CLIPBD && FilNamEdit->Text.IsEmpty()) {
			StatusBar1->SimpleText = "o̓t@Cw肵Ă";
			break;
		}
		if (DestMode==DSTMOD_SELDIR && DstDirEdit->Text.IsEmpty()) {
			StatusBar1->SimpleText = "o͏ꏊw肵Ă";
			break;
		}
		StatusBar1->SimpleText
			= UnicodeString().sprintf(_T("%u̓HTMLw肳Ă܂"), HtmLstCnt);
		ConvReady = true;
	} while (0);

	InhUpdateInf = false;
}

//---------------------------------------------------------------------------
//RpNg^ʏ\؂ւ
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::CompactBtnClick(TObject *Sender)
{
	int w, h;
	UnicodeString sct = "General";
	if (Compact) {
		Compact = false;
		IniFile->WriteInteger(   sct, "WinWidthC", 	Width);
		IniFile->WriteInteger(   sct, "WinHeightC",	Height);
		w = IniFile->ReadInteger(sct, "WinWidth",	NRM_MIN_WD);
		h = IniFile->ReadInteger(sct, "WinHeight",	NRM_MIN_HI);
	}
	else {
		Compact = true;
		IniFile->WriteInteger(   sct, "WinWidth", 	Width);
		IniFile->WriteInteger(   sct, "WinHeight",	Height);
		w = IniFile->ReadInteger(sct, "WinWidthC",	CMP_MIN_WD);
		h = IniFile->ReadInteger(sct, "WinHeightC",	CMP_MIN_HI);
	}

	TRect rc = BoundsRect;
	switch (CmpPosCombo->ItemIndex) {
	case 1:	//E
		rc.Left   = rc.Right - w;
		rc.Bottom = rc.Top + h;
		break;
	case 2:	//E
		rc.Left   = rc.Right - w;
		rc.Top	  = rc.Bottom - h;
		break;
	case 3:	//
		rc.Right  = rc.Left + w;
		rc.Top	  = rc.Bottom - h;
		break;
	default:	//E
		rc.Right  = rc.Left + w;
		rc.Bottom = rc.Top + h;
	}

	Constraints->MinWidth  = 0;
	Constraints->MinHeight = 0;
	BoundsRect = rc;

	if (Compact) {
		Constraints->MinWidth  = CMP_MIN_WD;
		Constraints->MinHeight = CMP_MIN_HI;
	}
	else {
		Constraints->MinWidth  = NRM_MIN_WD;
		Constraints->MinHeight = NRM_MIN_HI;
	}
	SetFrmStyle();
}

//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::LnWidEditChange(TObject *Sender)
{
	LnWidEdit->Font->Color = check_TUpDown(LnWidUpDown)? clWindowText : clRed;
}
//---------------------------------------------------------------------------
//sύX
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::BlkLmtEditaChange(TObject *Sender)
{
	BlkLmtEdit->Font->Color = check_TUpDown(BlkLmtUpDown)? clWindowText : clRed;
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::TitLmtEditChange(TObject *Sender)
{
	TitLmtEdit->Font->Color = check_TUpDown(TitLmtUpDown)? clWindowText : clRed;
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::NumberEditExit(TObject *Sender)
{
	TEdit *ep = (TEdit *)Sender;
	if (ep->Font->Color == clRed) {
		UnicodeString msg;  msg.sprintf(_T("͂l[%s]͔͈͂𒴂Ă܂"), ep->Text);
		Application->MessageBox(msg.c_str(), _T("x"), MB_OK + MB_ICONWARNING);
		ep->SetFocus();
	}
}

//---------------------------------------------------------------------------
//AvP[V̑I
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::RefAppBtnClick(TObject *Sender)
{
	OpenDialog1->Title		= "AvP[V̑I";
	OpenDialog1->Filter 	= "AvP[V (*.exe)|*.EXE";
	OpenDialog1->DefaultExt = "EXE";
	OpenDialog1->FileName	= "*.EXE";
	OpenDialog1->InitialDir = EmptyStr;
	if (OpenDialog1->Execute()) AppNameEdit->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------
//o͏ꏊ̎w
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::RefDstBtnClick(TObject *Sender)
{
	BROWSEINFO lpbi;
	_TCHAR path[MAX_PATH];

	lpbi.hwndOwner = Handle;
	lpbi.pidlRoot =  NULL;
	lpbi.pszDisplayName = path;
	lpbi.lpszTitle = _T("o͏ꏊ̎w");
	lpbi.ulFlags = BIF_RETURNONLYFSDIRS;
	lpbi.lpfn = NULL;
	lpbi.lParam = NULL;
	lpbi.iImage = 0;

	LPITEMIDLIST pIDlist = ::SHBrowseForFolder(&lpbi);
	if (pIDlist) {
		::SHGetPathFromIDList(pIDlist, path);
		DstDirEdit->Text = path;
	}

	::CoTaskMemFree(pIDlist);
}

//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::AltCheckClick(TObject *Sender)
{
	DefAltEdit->Enabled = AltCheck->Checked;
	AltBraEdit->Enabled = (AltCheck->Checked || ImgSrcCheck->Checked);
	AltKetEdit->Enabled = (AltCheck->Checked || ImgSrcCheck->Checked);
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::LinkCheckClick(TObject *Sender)
{
	ExtLnkCheck->Enabled = LinkCheck->Checked;
	LnkBraEdit->Enabled  = LinkCheck->Checked;
	LnkKetEdit->Enabled  = LinkCheck->Checked;
	LinkCrCheck->Enabled = LinkCheck->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::DestRadioBtnClick(TObject *Sender)
{
	DestMode = ((TComponent *)Sender)->Tag;
	UpdateInf(true);
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::JoinCheckClick(TObject *Sender)
{
	UpdateInf(true);
}

//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::HtmFileListClick(TObject *Sender)
{
	UpdateInf(true);
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::FilNamEditChange(TObject *Sender)
{
	FilNamEdit->Font->Color = clWindowText;
	UpdateInf(false);
}

//---------------------------------------------------------------------------
//̎Q
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::RefMac1BtnClick(TObject *Sender)
{
	PopTag = ((TComponent *)Sender)->Tag;
	POINT p;
	::GetCursorPos(&p);
	PopupMenu1->Popup(p.x, p.y);
}
//---------------------------------------------------------------------------
//̑}
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::PopRefItemClick(TObject *Sender)
{
	UnicodeString mstr = ((TMenuItem*)Sender)->Caption;
	int p = mstr.Pos(" ");
	if (p>0) mstr = mstr.SubString(1, p - 1);
	if (PopTag==0)
		HeadMemo->SetSelTextBuf(mstr.c_str());
	else
		FootMemo->SetSelTextBuf(mstr.c_str());
}

//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::Tit2NamCheckClick(TObject *Sender)
{
	TitLmtEdit->Enabled		= Tit2NamCheck->Checked;
	TitLmtUpDown->Enabled   = Tit2NamCheck->Checked;
	TitCvExChCheck->Enabled = Tit2NamCheck->Checked;
	TitCvSpcCheck->Enabled	= Tit2NamCheck->Checked;
}

//---------------------------------------------------------------------------
//I̎w
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::RefSndBtnClick(TObject *Sender)
{
	OpenDialog1->Title		= "I̎w";
	OpenDialog1->Filter 	= "WAVt@C (*.wav)|*.WAV";
	OpenDialog1->DefaultExt = "WAV";
	OpenDialog1->FileName	= "*.WAV";
	OpenDialog1->InitialDir = ExtractFileDir(EndSoundEdit->Text);
	if (OpenDialog1->Execute()) {
		EndSoundEdit->Text = OpenDialog1->FileName;
		::sndPlaySound(EndSoundEdit->Text.c_str(), SND_ASYNC);
	}
}
//---------------------------------------------------------------------------
//ĨeXgĐ
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::PlaySoundActionExecute(TObject *Sender)
{
	::sndPlaySound(EndSoundEdit->Text.c_str(), SND_ASYNC);
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::PlaySoundActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !EndSoundEdit->Text.IsEmpty();
}

//---------------------------------------------------------------------------
//ɎOɕ\
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::TopMostCheckClick(TObject *Sender)
{
	::EndDeferWindowPos(::DeferWindowPos(::BeginDeferWindowPos(1), Handle,
		(TopMostCheck->Checked? HWND_TOPMOST : HWND_NOTOPMOST), 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE));
}

//---------------------------------------------------------------------------
//WebTCgJ
//---------------------------------------------------------------------
void __fastcall TH2TconvForm::UrlLabelClick(TObject *Sender)
{
	::ShellExecute(NULL, _T("open"), SUPPORT_URL, NULL, NULL, SW_SHOWNORMAL);
}

//---------------------------------------------------------------------------
//ϊJn
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::ConvertExecute(TObject *Sender)
{
	Converting = true;
	ConvertAction->Enabled = false;
	Screen->Cursor = crHourGlass;	//v

	HC->TempDir 	 = ExtractFileDir(Application->ExeName);
	HC->LineWidth	 = LnWidEdit->Text.ToIntDef(80);
	HC->ForceCr 	 = FrcCrCheck->Checked;
	HC->BlankLnLimit = BlkLmtEdit->Text.ToIntDef(5);
	HC->NoPstHdr	 = PstHdrCheck->Checked;
	HC->HrLineStr	 = HrStrEdit->Text;
	HC->HeaderStr[0] = esc_to_str(H1Edit->Text);
	HC->HeaderStr[1] = esc_to_str(H2Edit->Text);
	HC->HeaderStr[2] = esc_to_str(H3Edit->Text);
	HC->HeaderStr[3] = esc_to_str(H4Edit->Text);
	HC->HeaderStr[4] = esc_to_str(H5Edit->Text);
	HC->HeaderStr[5] = esc_to_str(H6Edit->Text);
	HC->B_BraStr	 = esc_to_str(B_BraEdit->Text);
	HC->B_KetStr	 = esc_to_str(B_KetEdit->Text);
	HC->I_BraStr	 = esc_to_str(I_BraEdit->Text);
	HC->I_KetStr	 = esc_to_str(I_KetEdit->Text);
	HC->U_BraStr	 = esc_to_str(U_BraEdit->Text);
	HC->U_KetStr	 = esc_to_str(U_KetEdit->Text);
	HC->IndentStr	 = esc_to_str(IndentEdit->Text);
	HC->UlMarkStr	 = esc_to_str(MarkEdit->Text);
	HC->ZenNumber	 = ZenNoCheck->Checked;
	HC->CellSepStr	 = esc_to_str(CelSepEdit->Text);
	HC->UseAlt		 = AltCheck->Checked;
	HC->AddImgSrc	 = ImgSrcCheck->Checked;
	HC->DefAltStr	 = esc_to_str(DefAltEdit->Text);
	HC->AltBraStr	 = esc_to_str(AltBraEdit->Text);
	HC->AltKetStr	 = esc_to_str(AltKetEdit->Text);
	HC->InsLink 	 = LinkCheck->Checked;
	HC->OnlyExLink	 = ExtLnkCheck->Checked;
	HC->AddCrLink	 = LinkCrCheck->Checked;
	HC->LnkBraStr	 = esc_to_str(LnkBraEdit->Text);
	HC->LnkKetStr	 = esc_to_str(LnkKetEdit->Text);
	HC->InsLineStr	 = InsLineStrEdit->Text;
	HC->InsHrClass	 = InsHrClsEdit->Text;
	HC->InsHrSct	 = InsHrSctCheckBox->Checked;
	HC->InsHrArt	 = InsHrArtCheckBox->Checked;
	HC->InsHrNav	 = InsHrNavCheckBox->Checked;
	HC->DelBlkCls	 = DelBlkClsEdit->Text;
	HC->DelBlkId	 = DelBlkIdEdit->Text;

	if (InsHdCheck->Checked) HC->HeadStr = HeadMemo->Lines->Text;
	if (InsFtCheck->Checked) HC->FootStr = FootMemo->Lines->Text;

	//o͐fBNg
	UnicodeString dstdir = (DestMode==DSTMOD_SELDIR)? DstDirEdit->Text : OrgDir;
	if (!dstdir.IsEmpty()) dstdir = IncludeTrailingPathDelimiter(dstdir);

	switch (CodePageComboBox->ItemIndex) {
	case 1:  HC->OutCodePage = 50220;	break;	//JIS
	case 2:  HC->OutCodePage = 20932;	break;	//EUC
	case 3:  HC->OutCodePage = 65001;	break;	//UTF-8
	case 4:  HC->OutCodePage = 1200;	break;	//UTF-16
	default: HC->OutCodePage = 932;				//ShiftJIS
	}

	try {
		for (int i=0; i<HtmFileList->Items->Count; i++) HtmFileList->Selected[i] = false;
		for (int i=0; i<HtmFileList->Items->Count; i++) {
			UnicodeString htmfil = HtmFileList->Items->Strings[i];
			HtmFileList->Selected[i] = true;
			HtmFileList->Repaint();
			StatusBar1->SimpleText = "ϊ... " + htmfil;
			if (i==0 || !JoinCheck->Checked) HC->TxtBuf->Clear();
			if (HC->LoadFile(htmfil)) {;
				HC->Convert();
				if (DestMode!=DSTMOD_CLIPBD) {
					//o̓t@Cꍇ͂̓sxۑ
					if (HtmFileList->Items->Count>1 && !JoinCheck->Checked) {
						UnicodeString fnam = UrlToName(htmfil);
						if (Tit2NamCheck->Checked) fnam = TitToName(HC->TitleStr);
						if (DestMode==DSTMOD_SELDIR) fnam = dstdir + ExtractFileName(fnam);
						fnam = ChangeFileExt(fnam, ".txt");
						if (AddNoCheck->Checked) fnam = AddSerNo(fnam);
						if (!HC->SaveToFileCP(fnam)) throw EAbort("o̓t@C̕ۑɎs܂\r\n" + fnam);
					}
					//o̓t@C̏ꍇ
					else if (i==0 && (HtmFileList->Items->Count==1 || JoinCheck->Checked)) {
						if (Tit2NamCheck->Checked && !FilNamEdit->Modified) {
							FilNamEdit->Text = TitToName(HC->TitleStr) + ".txt";
						}
					}
				}
				HtmFileList->Selected[i] = false;
			}
			else
				throw EAbort("HTML擾ł܂\r\n" + htmfil);
			Application->ProcessMessages();
		}

		//ϊ̏
		StatusBar1->SimpleText = "ϊ!";
		if (!EndSoundEdit->Text.IsEmpty())
			::sndPlaySound(EndSoundEdit->Text.c_str(), SND_ASYNC);

		//Nbv{[hɃRs[
		if (DestMode==DSTMOD_CLIPBD)
			Clipboard()->AsText = HC->TxtBuf->Text;
		//o̓t@C̏ꍇ
		else if (HtmFileList->Items->Count==1 || JoinCheck->Checked) {
			UnicodeString fnam = dstdir + FilNamEdit->Text;
			if (AddNoCheck->Checked) fnam = AddSerNo(fnam);
			if (!HC->SaveToFileCP(fnam)) throw EAbort("o̓t@C̕ۑɎs܂\r\n" + fnam);
			if (OpenAppCheck->Checked && !AppNameEdit->Text.IsEmpty()) {
				fnam = "\""+ fnam + "\"";
				int res = (int)::ShellExecute(NULL, _T("open"),
					AppNameEdit->Text.c_str(), fnam.c_str(), NULL, SW_SHOWNORMAL);
				if (res<=32) throw EAbort("o̓t@CJ܂");
			}
		}

		//t@C̍폜
		do {
			if (!KillCheck->Checked) break;
			int i = 0;
			while (i<HtmFileList->Items->Count) {
				UnicodeString htm = HtmFileList->Items->Strings[i];
				if (StartsText("http://", htm) || StartsText("https://", htm))
					HtmFileList->Items->Delete(i);
				else
					i++;
			}
			if (HtmFileList->Items->Count==0) break;
			if (SureKillCheck->Checked) {
				if (Application->MessageBox(_T("HTML폜܂"), _T("x"),
					MB_OKCANCEL + MB_ICONWARNING)!=IDOK)
						break;
			}
			//ݔ
			if (UseTrashCheck->Checked) {
				SHFILEOPSTRUCT lpFileOp;
				std::unique_ptr<_TCHAR []> lpszFil(new _TCHAR[HtmFileList->Items->Text.Length()+4]);
				_TCHAR *p = lpszFil.get();
				for (int i=0; i<HtmFileList->Items->Count; i++) {
					_tcscpy(p, HtmFileList->Items->Strings[i].c_str());
					p += (_tcslen(p) + 1);
				}
				*p ='\0';
				lpFileOp.hwnd				   = Handle;
				lpFileOp.wFunc				   = FO_DELETE;
				lpFileOp.pFrom				   = lpszFil.get();
				lpFileOp.pTo				   = NULL;
				lpFileOp.fFlags 			   = FOF_ALLOWUNDO | FOF_NOCONFIRMATION;
				lpFileOp.fAnyOperationsAborted = true;
				lpFileOp.hNameMappings		   = NULL;
				lpFileOp.lpszProgressTitle	   = NULL;
				::SHFileOperation(&lpFileOp);
			}
			//폜
			else {
				for (int i=0; i<HtmFileList->Items->Count; i++) {
					UnicodeString fnam = HtmFileList->Items->Strings[i];
					if (!DeleteFile(fnam))
						throw EAbort("t@C폜ł܂\r\n" + fnam);
				}
			}
			HtmFileList->Clear();
			StatusBar1->SimpleText = "HTML폜܂!";
		} while (0);

		::Sleep(500);
	}
	catch(EAbort &e) {
		Application->MessageBox(e.Message.c_str(), _T("x"), MB_OK|MB_ICONEXCLAMATION);
	}

	Screen->Cursor = crDefault;
	Converting = false;
	UpdateInf(false);
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::ConvertActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = ConvReady && !Converting;
}

//---------------------------------------------------------------------------
//j[
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::MenuBtnClick(TObject *Sender)
{
	TPoint p = MenuBtn->ClientToScreen(Point(MenuBtn->Left + 8, MenuBtn->Top + 8));
	ToolMenu->Popup(p.x, p.y);
}
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::AbautMeasureItem(TObject *Sender,
      TCanvas *ACanvas, int &Width, int &Height)
{
	//𒲐
	if (((TComponent *)Sender)->Tag>1000)
		Width = std::max(Width, 44 + ACanvas->TextWidth(VersionStr));
	else
		Width += 8;
	//𒲐
	Height += 2;
}

//---------------------------------------------------------------------------
//ݒt@CJ
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::LoadIniItemClick(TObject *Sender)
{
	OpenDialog1->Title		= "ݒt@CJ";
	OpenDialog1->Filter 	= "ݒt@C (*.ini)|*.INI";
	OpenDialog1->FileName	= "*.ini";
	OpenDialog1->InitialDir = LastIniDir;
	if (OpenDialog1->Execute()) {
		LoadIniFile(OpenDialog1->FileName);
		LastIniDir = ExtractFileDir(OpenDialog1->FileName);
	}
}
//---------------------------------------------------------------------------
//ݒɖOtĕۑ
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::SaveIniItemClick(TObject *Sender)
{
	SaveDialog1->Title		= "ݒt@CɖOtĕۑ";
	SaveDialog1->Filter 	= "ݒt@C (*.ini)|*.INI";
	SaveDialog1->DefaultExt = "INI";
	SaveDialog1->FileName	= "*.ini";
	SaveDialog1->InitialDir	= LastIniDir;
	if (SaveDialog1->Execute()) {
		SaveIniFile(SaveDialog1->FileName);
		LastIniDir = ExtractFileDir(SaveDialog1->FileName);
	}
}
//---------------------------------------------------------------------------
//ݒftHgɖ߂
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::DefaultIniItemClick(TObject *Sender)
{
	if (FileExists(IniFile->FileName)) DeleteFile(IniFile->FileName); 
	LoadIniFile();
}
//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::HelpItemClick(TObject *Sender)
{
	Application->HelpShowTableOfContents();
}

//---------------------------------------------------------------------------
//o[W`
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::AbautInfItemDrawItem(TObject *Sender,
      TCanvas *ACanvas, TRect &ARect, bool Selected)
{
	TMenuItem *tp =(TMenuItem*)Sender;
	ACanvas->Brush->Color = clBlack;
	ACanvas->FillRect(ARect);
	RECT rc = RECT(ARect);
	TFontStyles fstyle;

	switch (tp->Tag) {
	case 1001:	//㔼
		ACanvas->Draw(ARect.Left + 4, ARect.Bottom - 16, Application->Icon);
		fstyle.Clear(); fstyle << fsBold;
		ACanvas->Font->Style = fstyle;
		ACanvas->Font->Color = clWhite;
		ACanvas->TextOut(ARect.Left + 44, ARect.Top + 2, Application->Title);
		DrawEdge(ACanvas->Handle, &rc, BDR_SUNKENOUTER, BF_TOP|BF_LEFT|BF_RIGHT);
		break;
	case 1002:	//
		ACanvas->Draw(ARect.Left + 4, ARect.Top - 16, Application->Icon);
		ACanvas->Font->Color = clWhite;
		ACanvas->TextOut(ARect.Left + 48, ARect.Top + 2, VersionStr);
		DrawEdge(ACanvas->Handle, &rc, BDR_SUNKENOUTER, BF_BOTTOM|BF_LEFT|BF_RIGHT);
		break;
	}
}

//---------------------------------------------------------------------------
//Weby[WJ
//---------------------------------------------------------------------------
void __fastcall TH2TconvForm::GoWebItemClick(TObject *Sender)
{
	::ShellExecute(NULL, _T("open"), SUPPORT_URL, NULL, NULL, SW_SHOWNORMAL);
}
//---------------------------------------------------------------------------

